import es, os, os.path
#
# Easy Downloads Library Version 4, by Ojii
# 
### This is the public class ###
class downloadables:
    def __init__(self):
        self.dls = []
        self.root = "%s/" % str(es.ServerVar('eventscripts_gamedir')).replace('\\','/')
    # Adding downloads. path is relative to the games root path. ignore can be a list of endings to ignore. maxsize can be a maximum filesize
    def add(self,path,ignore=None,only=None,maxsize=None):
        maxsize = getBytes(maxsize)
        path = path.replace('\\','/')
        if path.startswith('/'):
            path = path[1:]
        object = self.root + path
        if ignore and type(ignore) != list:
            ignore = [ignore]
        if only and type(only) != list:
            only = [only]
        if os.path.isfile(object) and path not in self.dls and not doIgnore(path,ignore) and doOnly(path,only):
            if maxsize and os.path.getsize(self.root + path) > maxsize:
                es.dbgmsg(1,'file to big: %s' % path)
            else:
                es.dbgmsg(1,'adding: %s' % path)
                self.dls.append(path)
        elif os.path.isdir(object):
            if not path.endswith('/'):
                path += '/'
            filelist = getRecursiveList(path,object,ignore,only)
            for thing in filelist:
                if not thing in self.dls:
                    if maxsize and os.path.getsize(self.root + thing) > maxsize:
                        es.dbgmsg(1,'file to big: %s' % thing)
                    else:
                        es.dbgmsg(1,'adding: %s' % thing)
                        self.dls.append(thing)
        else:
            es.dbgmsg(0,'%s is not a folder or file' % object)
    # Applies list to stringtable
    def apply(self):
        for dl in self.dls:
            es.dbgmsg(1,'applying %s' % dl)
            es.stringtable('downloadables', dl)
    # Removes path from the lsit
    def remove(self,path):
        path = path.replace('\\','/')
        if path.startswith('/'):
            path = path[1:]
        object = os.path.join(self.root,path)
        if os.path.isfile(object) and path in self.dls:
            es.dbgmsg(1,'removing: %s' % thing)
            self.dls.remove(path)
        elif os.path.isdir(object):
            if not path.endswith('/'):
                path += '/'
            filelist = getRecursiveList(path,object)
            for thing in filelist:
                if thing in self.dls:
                    es.dbgmsg(1,'removing: %s' % thing)
                    self.dls.remove(thing)
            
### Following functions are helpers for the class ###
def getRecursiveList(relativ,absolut,ignore,only):
    rl = []
    for root, dirs, files in os.walk(absolut):
        current = root.replace(absolut,'')
        for f in files:
            if doOnly(f,only) and not doIgnore(f,ignore):
                rl.append(os.path.join(relativ,current,f).replace('\\','/')
    return rl
    
def doIgnore(name,ignore):
    if not type(ignore) == list:
        return False
    for i in ignore:
        if name.endswith(i):
            return True
    return False
    
def doOnly(name,only):
    if not type(only) == only:
        return True
    for o in only:
        if name.endswith(o):
            return True
    return False
    
def getBytes(s):
    if not s:
        return None
    if type(s) == int:
        return s
    elif s.isdigit():
        return int(s)
    else:
        s = s.lower()
        if s.endswith('gb'):
            return int(s[:-2]) * 1073741824
        elif s.endswith('mb'):
            return int(s[:-2]) * 1048576
        elif s.endswith('kb'):
            return int(s[:-2]) * 1024
        else:
            return None